﻿from tkinter import *
import time,math
a = 10; b = 3; dt = 0.004 ; g = 0
#a = 10; b = 3; dt = 0.004 ; g = 10
dg = 1; XS = 30; YS = 20; ZS = 30
def screenX(X, Y) : return 5 * (X - 0.6 * Y) + 200
def screenY(Y, Z) : return 350 - 5 * (Z - 0.6 * Y)

def Line3D(X1, Y1, Z1, X2, Y2, Z2, C, w):
    global canvas
    XS1 = int(screenX(X1, Y1) + 0.5)
    YS1 = int(screenY(Y1, Z1) + 0.5);
    XS2 = int(screenX(X2, Y2) + 0.5);
    YS2 = int(screenY(Y2, Z2) + 0.5);
    canvas.create_line(XS1, YS1, XS2, YS2, fill=C, width=w, tag="DT")
def Coord3D():
    Line3D(-30,   0,   0, 50,  0,  0, "#FF0000",2)
    Line3D(  0, -30,   0,  0, 50,  0, "#007700",2)
    Line3D(  0,   0, -30,  0,  0, 50, "#000077",2)
def dspValue():
    global g
    canvas.create_text(250, 20 ,text="g = %7.4f" % g,
                       font=('ＭＳ ゴシック',10),fill="#FFFF00", tag="DT")
    canvas.create_text(250, 40 ,
                       text="黄緑：XY平面への投影,青色:XZ平面への投影, 黄色:3D座標の位置",
                       font=('ＭＳ ゴシック',10),fill="#FFFF00", tag="DT")
#■表示用計算
def cmpIter():
    global XS, YS, ZS, dt, a, b,g
    canvas.delete("DT")
    dspValue()
    X= XS; Y = YS; Z = ZS
    Coord3D()
    for i in range(6000):
        XN = X + dt * a * (Y - X)
        YN = Y + dt * (-X * Z + g * X - Y)
        ZN = Z + dt * (X * Y - b * Z)
        Line3D(X, Y, 0, XN, YN,  0, "#00FF00", 1)
        Line3D(X, 0, Z, XN,  0, ZN, "#0000FF", 1)
        Line3D(X, Y, Z, XN, YN, ZN, "#FFFF00", 1)
        X = XN; Y = YN; Z = ZN
    root.update()
#■待ち処理等
def wait():
    tk.update_idletasks()
    time.sleep(0.0001)
def strdt(DT):
    return "B = %+5.2f" % DT
#■ マウスイベントによる次の描画
def leftMouseDown(event): 
    global g, dg
    if abs(g-30)<0.00001: g = 0
    g = g + dg ; cmpIter()
    
#■メイン処理
#キャンバスの定義
root=Tk()
root.title("Lorenz Model")
canvas=Canvas(root, width=500,height=500,bg="#000000")
canvas.pack()

#開始
canvas.bind("<Button-1>",leftMouseDown)
root.mainloop()
while True:
    cmpIter()
    root.update_idletasks()
    root.update()
    time.sleep(0.01)
    if abs(g-30)<0.00001: break
    g = g + dg ; cmpIter()






    
